<template>

<tr
    v-if="columns"
>
    <td class="
        px-2
        lg:px-4
        py-1
    ">
        <div
            v-if="! point._hidden"
            class="
            flex
            w-full
            justify-center
        ">
            <button
                title="Click and hold to be able to move the line, which will change it's number"
                id="dragula"
                class="
                cursor-move
                flex
                hover:text-blue-500
                dark:hover:text-blue-400
                p-1
                rounded-full
            ">
                <IconBase
                    id="dragula"
                    name="menu"
                    size="16"
                />
            </button>
        </div>
    </td>
    <td
        class="
        px-1
        lg:px-4
        py-1
        text-sm
    ">
        <p
            v-bind:class="{ 'invisible': point._hidden }"
            class="
            text-center
        ">
            <b>
                {{ point.getNumber() }}
            </b>
        </p>
    </td>
    <td
        v-bind:key="key"
        v-for="(value, key) in columns"
        v-bind:class="{ 'opacity-50' : point._hidden }"
        class="
        px-1
        lg:px-4
        py-1
        text-sm
        text-right
    ">
        <p
            v-if="project.reports.current.values.current === value"
            v-bind:style="{ color: genColor() }"
            class="
            text-right
            font-black
        ">
            {{ point.values[value].value.toDisplayedNumber().toString() }}
        </p>
        <p
            v-else
            class="
            text-right
        ">
            {{ point.values[value].value.toDisplayedNumber().toString() }}
        </p>
    </td>
    <td class="
        px-2
        lg:px-4
        py-1
    ">
        <div class="
            flex
            w-full
            justify-center
        ">
            <button
                title="Click here to hide the point on the map"
                v-on:click="togglePoint"
                class="
                flex
                hover:text-blue-500
                dark:hover:text-blue-400
                p-1
                rounded-full
            ">
                <IconBase
                    v-bind:name="point._hidden ? 'eyeOff' : 'eye'"
                    size="16"
                />
            </button>
        </div>
    </td>
</tr>

</template>

<script lang='ts'>

import { Component, Prop, Vue } from 'vue-property-decorator';
import { State } from 'vuex-class';

import * as Numeral from 'numeral';

import IconBase from '@/components/IconBase.vue';

import { Point } from '@/ts/point';
import { Project } from '@/ts/project';
import { blend } from '@/ts/utils/blender';

@Component({
    components: {
        IconBase,
    },
})
export default class C extends Vue {
    @State('project')
    private project!: Project;

    @Prop()
    private point!: Point;

    @Prop()
    private columns!: string[];

    private async togglePoint() {
        if (this.project.reports.current) {
            this.project.reports.current.points.hide(this.point);
            this.project.update();
        }
    }

    private genColor(): string {
        if (window.matchMedia('(prefers-color-scheme: dark)').matches) {
            return this.point.getColor();
        } else {
            return blend(this.point.getColor(), '#000000', 0.3);
        }
    }
}

</script>
